<?php
/**
 * Asalae\Controller\{{ name }}Controller
 */

namespace {{ namespace }}\Controller;

use {{ defaultModel }};
use AsalaeCore\Controller\Component\IndexComponent;
use AsalaeCore\Controller\RenderDataTrait;
use AsalaeCore\Utility\FormatError;
use Cake\Http\Response;
use Exception;

/**
 * {{ name }}
 *
 * @category Controller
 *
 * @author    Libriciel SCOP <contact@libriciel.coop>
* @copyright (c) {{ "now"|date("Y") }}, Libriciel
* @license   https://www.gnu.org/licenses/agpl-3.0.txt
{% if defaultModel %}
    * @property {{ name }}Table {{ name }}
{% endif %}

{%- for component in components %}
    {% set classInfo = Bake.classInfo(component, 'Controller/Component', 'Component') %}
    * @property {{ classInfo.fqn }} ${{ classInfo.name }}
{% endfor %}
*/
class {{ name }}Controller extends AppController
{
/**
* Traits
*/
use RenderDataTrait;

/**
* Options de pagination par défaut
* @var array
*/
public $paginate = [
'limit' => 10,
'order' => [
'{{ name }}.id' => 'asc'
]
];

/**
* Liste les enregistrements
*/
public function index()
{
$this->loadComponent('AsalaeCore.Index');
$this->Index->init();

$query = $this->{{ name }}->find();

$this->Index->setQuery($query)
->filter('name', IndexComponent::FILTER_ILIKE);
$data = $this->paginate($query)->toArray();
$this->set('data', $data);
}

/**
* Action d'ajout
*/
public function add()
{
$entity = $this->{{ name }}->newEntity([], ['validate' => false]);

if ($this->getRequest()->is('post')) {
$data = $this->getRequest()->getData();
$this->{{ name }}->patchEntity($entity, $data);
$this->loadComponent('AsalaeCore.Modal');
if ($this->{{ name }}->save($entity)) {
$this->Modal->success();
return $this->renderJson(json_encode($entity->toArray()));
} else {
$this->Modal->fail();
FormatError::logEntityErrors($entity);
}
}
$this->set('entity', $entity);
}

/**
* Action modifier
* @param string $id
* @return Response|null|void
* @throws Exception
*/
public function edit(string $id)
{
$entity = $this->{{ name }}->get($id);

if ($this->getRequest()->is('put')) {
$data = $this->getRequest()->getData();
$this->{{ name }}->patchEntity($entity, $data);
$this->loadComponent('AsalaeCore.Modal');
if ($this->{{ name }}->save($entity)) {
$this->Modal->success();
return $this->renderJson(json_encode($entity->toArray()));
} else {
$this->Modal->fail();
FormatError::logEntityErrors($entity);
}
}

$this->set('entity', $entity);
}

/**
* Action supprimer
* @param string $id
*/
public function delete(string $id)
{
$this->getRequest()->allowMethod('delete');
$entity = $this->{{ name }}->get($id);

$report = $this->{{ name }}->delete($entity)
? 'done'
: 'Erreur lors de la suppression';

return $this->renderDataToJson(['report' => $report]);
}
}
